0a1,4
> /*
> static char sccsid[] = "@(#)67  1.1  src/com/ibm/cim/CIMClass.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:05";
> */
> 
74d77
< package org.snia.wbem.cim;
76c79,81
< import java.net.MalformedURLException;
---
> package com.ibm.cim;
> 
> 
78,93c83,97
< import java.io.Serializable;
< import org.snia.wbemcmd.xml.*;
< //
< //
< public class CIMClass  extends CIMElement implements Serializable {
<     private static Vector emptyMethods=new Vector();	// people should not modify the
< 							// returned vectors so we can use
< 							// a static entry for when no methods
< 							// are set -- this saves memory because
< 							// many classes don't have methods!
<     private String parentClassName=null;	// Name of parent class
<     private Vector qualifiers=new Vector();	// CIMQualifier
<     private Vector properties=new Vector();	// CIMProperty
<     private Vector methods=new Vector();	// CIMMethod
<     private boolean associationFlag;		// TRUE if an association
<     private boolean isKeyed=false;		// TRUE when class has keys
---
> import java.net.MalformedURLException;
> import com.ibm.xml.*;
> 
> 
> 
> /**
>  *	CIM Class
>  */
> public class CIMClass extends CIMElement {
> 
> 
> 	/**
> 	 *	Parent Class name
> 	 */
> 	private String superClass;
95,101c99,102
<     //
<     // CIMClass
<     //
<     // Creates a class
<     //
<     public CIMClass() {
<     }
---
> 	/**
> 	 *	Qualifiers of the class   CIMQualifiers
> 	 */
> 	private Vector qualifiers;
103,109c104,146
<     //
<     // CIMClass
<     //
<     // Creates a class with the specified name
<     //
<     public CIMClass(String nname) {
< 	setName(nname); 
---
> 	/**
> 	 *	Properties of the class	CIMProperty
> 	 */	
> 	private Vector properties;
> 
> 	/**
> 	 *	Metods of the class CIMMethod
> 	 */
> 	private Vector methods;
> 
> 	/**
> 	 *	Describes if the class is an Association
> 	 */
> 	private boolean isAssociation;
> 
> 	private boolean isKeyed=false;		// TRUE when class has keys
> 
> 	/**
> 	 *	Constructor
> 	 */
> 
> 	public CIMClass(){
> 		super("");
> 		this.superClass = new String("");
> 		qualifiers = new Vector();
>         properties = new Vector();
>         methods = new Vector();
>         isAssociation = false;
> 	}
> 
> 
> 	/**
>      *  Constructor
>      */
> 
>     public CIMClass(String className){
>         super(className);
>         this.superClass = new String("");
> 		qualifiers = new Vector();
>         properties = new Vector();
>         methods = new Vector();
>         isAssociation = false;
> 
122a160,162
> 	qualifiers = new Vector();
> 	properties = new Vector();
> 	methods = new Vector();
172,173c212
< 	    System.err.println("Failed to create class:"+ce.toString());
< 	    throw new java.lang.InstantiationError(ce.toString());
---
> 	 	throw new java.lang.InstantiationError(ce.toString());
177,194c216,222
<     
<     //
<     // toString
<     public String toString() {
< 	int i;
< 	
< 	String ret=new String();
< 	
< 	if (qualifiers.size()!=0) {
< 	     ret=ret.concat("[\n");
< 	     if (associationFlag)
< 		ret=ret.concat("ASSOCIATION,");
< 	     for(i=0;i<qualifiers.size();i++) {
< 		if (i>0)
< 		    ret=ret.concat(",");
< 		ret=ret.concat(((CIMQualifier)(qualifiers.elementAt(i))).toMOF());
< 	     }
< 	     ret=ret.concat("]\n");
---
> 
> 
> 	/**
> 	 *	Returns name of the parent class
> 	 */
> 	public String getSuperClass(){
> 		return superClass;
196,197d223
< 	ret=ret.concat("class ");
< 	ret=ret.concat(getName());
199,201c225,229
< 	if (parentClassName!=null) {
< 	    ret=ret.concat(":");
< 	    ret=ret.concat(parentClassName);
---
> 	/**
> 	 *	Sets name of the parent class
> 	 */
> 	public void setSuperClass(String parent){
> 		this.superClass = parent;
203,205d230
< 	ret=ret.concat("\n{\n");
< 	for(i=0;i<properties.size();i++)
< 	    ret=ret.concat(((CIMProperty)(properties.elementAt(i))).toMOF());
207,209c232,237
< 	if (methods!=null) {
< 	    for(i=0;i<methods.size();i++)
< 		ret=ret.concat(((CIMMethod)(methods.elementAt(i))).toMOF());
---
> 
> 	/**
> 	 * returns true if class is an association
> 	 */
> 	public boolean isAssociation(){
> 		return this.isAssociation;
211,213d238
< 	ret=ret.concat("};\n");
< 	return(ret);
<     }
215,234c240,244
<     //
<     // toMOF
<     // 
<     // Returns a MOF representation
<     //
<     public String toMOF() {
< 	int i;
< 	
< 	String ret=new String();
< 	
< 	if (qualifiers.size()!=0) {
< 	     ret=ret.concat("[\n");
< 	     if (associationFlag)
< 		ret=ret.concat("ASSOCIATION,");
< 	     for(i=0;i<qualifiers.size();i++) {
< 		if (i>0)
< 		    ret=ret.concat(",");
< 		ret=ret.concat(((CIMQualifier)(qualifiers.elementAt(i))).toMOF());
< 	     }
< 	     ret=ret.concat("]\n");
---
> 	/**
> 	 * sets if class is an association or not
> 	 */
> 	public void setIsAssociation(boolean association){
> 		this.isAssociation = association;
236,237d245
< 	ret=ret.concat("class ");
< 	ret=ret.concat(getName());
239,241c247,254
< 	if (parentClassName!=null) {
< 	    ret=ret.concat(":");
< 	    ret=ret.concat(parentClassName);
---
> 
> 	 //
> 	 // isKeyed
> 	 //
> 	 // Returns true if class has keyed properties. 
> 	 //
> 	public boolean isKeyed() {
> 	 	return(isKeyed);
243,245d255
< 	ret=ret.concat("\n{\n");
< 	for(i=0;i<properties.size();i++)
< 	    ret=ret.concat(((CIMProperty)(properties.elementAt(i))).toMOF());
247,249c257,264
< 	if (methods!=null) {
< 	    for(i=0;i<methods.size();i++)
< 		ret=ret.concat(((CIMMethod)(methods.elementAt(i))).toMOF());
---
> 	//
> 	// setIsKeyed
> 	//
> 	// Sets whether this class
> 	// has keys 
> 	// 
> 	public void setIsKeyed(boolean isKeyedValue) {
> 		isKeyed=isKeyedValue;
251,274d265
< 	ret=ret.concat("};\n");
< 	return(ret);
<     }
<  
<     
<     //
<     // getSuperClass
<     //
<     // Returns the name of the parent for this class 
<     //
<     public String getSuperClass() {
< 	if (parentClassName==null)
< 	    return(null);
< 	return(parentClassName);
<     }
<  
<     //
<     // SetSuperClass
<     //
<     // Sets the name of the parent class of this class 
<     //
<     public void setSuperClass(String sClass) {
< 	parentClassName=sClass;
<     }
276,302c267,291
<     //
<     // isKeyed
<     //
<     // Returns true if class has keyed properties. 
<     //
<     public boolean isKeyed() {
< 	return(isKeyed);
<     }
<     
<     //
<     // setIsKeyed
<     //
<     // Sets whether this class has keys 
<     //
<     public void setIsKeyed(boolean isKeyedValue) {
< 	isKeyed=isKeyedValue;
<     } 
<     
<     //
<     // Returns the properties that are keys for this class
<     //
<     public Vector getKeys() {
< 	Vector v=new Vector();
< 	for(int i=0;i<properties.size();i++) {
< 	    CIMProperty p=((CIMProperty)(properties.elementAt(i)));
< 	    if (p.isKey())
< 		v.addElement(p);
---
> 
> 	/**
> 	 *	Creates new Instance of this class
> 	 */
> 	public CIMInstance newInstance() {
> 		CIMInstance cimInst = new CIMInstance();
> 		cimInst.setClassName(name);
> 
> 
> 		if(properties != null) {
> 			Vector propVect = new Vector();
> 			for(int i=0;i<properties.size();i++) {
> 				propVect.addElement(((CIMProperty)properties.elementAt(i)).clone());
> 			}
> 			cimInst.setProperties(propVect);
> 		}	
> 				
> 		if(qualifiers != null) {
> 			Vector qualVect = new Vector();
> 			for(int i=0;i<qualifiers.size();i++) {
> 				qualVect.addElement(((CIMQualifier)qualifiers.elementAt(i)).clone());
> 			}
> 			cimInst.setQualifiers(qualVect);
> 		}	
> 		return cimInst;
304,316c293,308
< 	return(v);
<     }
<  
<     //
<     // getQualifier
<     //
<     // Returns the qualifier in this class
<     //
<     public CIMQualifier getQualifier(String name) {
< 	for(int i=0;i<qualifiers.size();i++) {
< 	    CIMQualifier q=((CIMQualifier)(qualifiers.elementAt(i)));
< 	    if (q.getName().equalsIgnoreCase(name))
< 		return(q);
---
> 
> 
> 	/**
> 	 *	Returns Keys for this class
> 	 */
> 	public Vector getKeys() {
> 		Vector keyVect = new Vector();
> 		if (properties != null) {
> 			for (int i=0; i<properties.size() ; i++) {
> 				CIMProperty cimProp = (CIMProperty)properties.elementAt(i);
> 				if(cimProp.isKey()) {
> 					keyVect.addElement(cimProp);
> 				}
> 			}	
> 		}	
> 		return keyVect;
318,319d309
< 	return(null);
<     }
322,346c312,317
<     
<  
<     //
<     // getProperty
<     //
<     // Returns the requested CIMProperty
<     //
<     public CIMProperty getProperty(String propName) {
< 	String oClass;
< 	
< 	//
< 	// See if property name is in the form originClass.propName
< 	// and if it is, work to find real origin class
< 	//
< 	oClass=splitName1(propName);
< 	if (oClass!=null) {
< 	    propName=splitName2(propName);
< 	    for(int i=0;i<properties.size();i++) {
< 		CIMProperty cp=(CIMProperty)(properties.elementAt(i));
< 		if (!cp.getOriginClass().equalsIgnoreCase(oClass)
< 		    && (cp.getName().equalsIgnoreCase(propName)))
< 		    return(cp);
< 	    }
< 	    return(null);
< 	} 
---
> 	/**
> 	 *	Returns all the qualifiers of the class
> 	 */
> 	public Vector getQualifiers() {
> 		return this.qualifiers;
> 	}	
348,355d318
< 	for(int i=0;i<properties.size();i++) {
< 	    CIMProperty cp=(CIMProperty)(properties.elementAt(i));
< 	    
< 	    if (cp.getName().equalsIgnoreCase(propName))
< 		return(cp);
< 	}
< 	return(null);
<     }
357,366c320,325
<  
<     //
<     // getProperty
<     //
<     // Returns the specified CIMProperty from the specified
<     // originating class.
<     //
<     public CIMProperty getProperty(String name,String originClass) {
< 	return(getProperty(name+"."+name));
<     } 
---
> 	/**
> 	 *	Sets  qualifiers of the class
> 	 */
> 	public void setQualifiers(Vector qualVect) {
> 		this.qualifiers = qualVect;
> 	}	
368,374c327,333
<     //
<     // getMethod
<     //
<     // Returns the specified method 
<     //
<     public CIMMethod getMethod(String methodName) {
< 	String oClass;
---
> 
> 	/**
> 	 *	adds specified qualifier 
> 	 */
> 	public void addQualifier(CIMQualifier cimQual) {
> 		qualifiers.addElement(cimQual);
> 	}	
376,388c335,347
< 	//
< 	// See if method name is in the form originClass.propName
< 	// and if it is, work to find real origin class
< 	//
< 	oClass=splitName1(methodName);
< 	if (oClass!=null) {
< 	    if (methods!=null) {
< 		int tsize=methods.size();
< 		for(int i=0;i<tsize;i++) {
< 		    CIMMethod q=((CIMMethod)(methods.elementAt(i)));
< 		    if (!q.getOriginClass().equalsIgnoreCase(oClass) 
< 			&& (q.getName().equalsIgnoreCase(methodName)))
< 			return(q);
---
> 	/**
> 	 *	removes specified  qualifier 
> 	 */
> 	public boolean removeQualifier(CIMQualifier cimQual) {
> 		if(qualifiers != null) {
> 			int size  = qualifiers.size();
> 			for (int i=0; i<size ; i++) {
> 				CIMQualifier cq = (CIMQualifier)qualifiers.elementAt(i);
> 				if(cq.equals(cimQual)) {
> 					qualifiers.removeElementAt(i);
> 					return true;
> 				}
> 			}
390,415c349,350
< 	    }
< 	    return(null);
< 	} 
< 	if (methods!=null) {
< 	    int tsize=methods.size();
< 	    for(int i=0;i<tsize;i++) {
< 		CIMMethod q=((CIMMethod)(methods.elementAt(i)));
< 		if (q.getName().equalsIgnoreCase(methodName))
< 		    return(q);
< 	    }
< 	}
< 	return(null);
<     }
<  
<  
<  
<     //
<     // getMethod
<     //
<     // Returns the specified method from the originating
<     // class given
<     //
<     public CIMMethod getMethod(String name,String originClass)	{
< 	return(getMethod(originClass+"."+name));
<     }	 
< 				
---
> 		return false;
> 	}	
418,425c353,367
<     //
<     // isAssociation
<     // 
<     // Returns TRUE if the class is an association else FALSE
<     //
<     public boolean isAssociation() {
< 	return(associationFlag);
<     }
---
> 	/**
> 	 *	returns true if class has given qualifier 
> 	 */
> 	public boolean hasQualifier(CIMQualifier cimQual) {
> 		if(qualifiers != null) {
> 			int size  = qualifiers.size();
> 			for (int i=0; i<size ; i++) {
> 				CIMQualifier cq = (CIMQualifier)qualifiers.elementAt(i);
> 				if(cq.equals(cimQual)) {
> 					return true;
> 				}
> 			}
> 		}
> 		return false;
> 	}	
428,451d369
<     //
<     // setIsAssociation
<     //
<     // Sets whether this class is an association 
<     //
<     public void setIsAssociation(boolean isAssociation) {
< 	associationFlag=isAssociation;
<     }
<   
<     //
<     // getQualifiers
<     //
<     // Gets the qualifiers
<     //
<     public Vector getQualifiers() {
< 	return(qualifiers);
<     }
<  
<     //
<     // Gets the properties (including overridden ones)
<     //	
<     public Vector getAllProperties() {
< 	return(properties);
<     }
452a371,380
> 	/**
> 	 *	returns number of qualifier 
> 	 */
> 	public int numberOfQualifiers() {
> 		int size =0;
> 		if(qualifiers != null) {
> 			size  = qualifiers.size();
> 		}
> 		return size;
> 	}	
455,460c383,397
<     //
<     // Gets the properties for this CIM class - filters
<     // out overides
<     // 
<     public Vector getProperties() {
< 	Vector prop=new Vector();
---
> 	/**
> 	 *	Returns qualifier of given name
> 	 */
> 	public CIMQualifier getQualifier(String qualName) {
> 		if(qualifiers != null) {
> 			int size = qualifiers.size();
> 			for (int i=0; i<size ; i++) {
> 				CIMQualifier cimQual = (CIMQualifier) qualifiers.elementAt(i);
> 				if ((cimQual.getName()).equalsIgnoreCase(qualName)) {
> 					return cimQual;
> 				}	
> 			}	
> 		}
> 		return null;
> 	}	
462,471c399,488
< 	String className = getName();
< 	
< 	for(int i=0;i<properties.size();i++) {
< 	    CIMProperty cp=(CIMProperty)(properties.elementAt(i));
< 	    //
< 	    // Not an obvious override, but if the origin class is 
< 	    // to this classname then return the property
< 	    String oClass = cp.getOriginClass();
< 	    if (oClass.equals(className))
< 		prop.addElement(cp);
---
> 	/**
> 	 *	Returns all the properties of the class
> 	 *	Includes those which were overriden
> 	 */
> 	public Vector getAllProperties() {
> 		return this.properties;
> 	}	
> 
> 	/**
> 	 *	Sets  properties of the class
> 	 */
> 	public void setProperties(Vector propVect) {
> 		this.properties = propVect;
> 	}	
> 
> 	/**
> 	 *	adds specified property 
> 	 */
> 	public void addProperty(CIMProperty cimProp) {
> 		properties.addElement(cimProp);
> 	}	
> 
> 	/**
> 	 *	returns number of porperties 
> 	 */
> 	public int numberOfProperties() {
> 		int size =0;
> 		if(properties != null) {
> 			size  = properties.size();
> 		}
> 		return size;
> 	}	
> 
> 
> 
> 	/**
> 	 *	Returns all the properties of the class
> 	 *	doesn't include those which were overriden
> 	 */
> 	public Vector getProperties() {
> 		Vector prop = new Vector();
> 		if(properties != null) {
> 			int size = properties.size();
> 			for(int i=0;i<size;i++){
> 				CIMProperty cimProp = (CIMProperty) properties.elementAt(i);
> 				if((cimProp.getOriginClass()).equalsIgnoreCase(this.name)) {
> 					prop.addElement(cimProp);
> 				}
> 			}	
> 		}	
> 		return prop;
> 	}	
> 
> 
> 	/**
> 	 *	returns property with specified name
> 	 */
> 	public CIMProperty getProperty(String propName) {
> 		CIMProperty cp = null;
> 		String className = null;
> 		String pName = null;
> 
> 		if (propName != null) {
> 			int i = propName.indexOf('.');
> 			if(i >=0 ) {
> 				//property name in form of classname.propertyname
> 				className = propName.substring(0,i);
> 				pName = propName.substring(i+1,propName.length());
> 			} else {
> 				pName = propName;
> 			}	
> 
> 			int size = properties.size();
> 			for(int j=0; j <size; j++){
> 				CIMProperty cimProp = (CIMProperty)properties.elementAt(j);
> 				if(className != null) {
> 					if((cimProp.getOriginClass()).equalsIgnoreCase(className)
> 					&&	((cimProp.getName()).equalsIgnoreCase(pName))) {
> 						return cimProp;
> 					}	
> 
> 				} else {
> 					if((cimProp.getName()).equalsIgnoreCase(pName)) {
> 						return cimProp;
> 					}	
> 				}
> 
> 			}
> 		}	
> 		return cp;
473,500c490,496
< 	return(prop);  
<     }
<  
<  
<  
<     // Gets the methods for this CIM class (includes overridden ones) 
<     // 
<     public Vector getAllMethods() {
< 	if (methods==null)
< 	    return(emptyMethods);
< 	return(methods);
<     }
<  
<  
<  
<     //
<     // Gets the methods - but not overriden ones
<     // 
<     public Vector getMethods() {
< 	Vector meth=new Vector();
< 	
< 	if (methods!=null) {
< 	    int tsize=methods.size();
< 	    for(int i=0;i<tsize;i++) {
< 	    CIMMethod cp=(CIMMethod)(methods.elementAt(i));
< 	    if (cp.getQualifier(CIMQualifier.CIM_QUAL_OVERRIDE)==null)
< 		meth.addElement(cp);
< 	    }
---
> 
> 
> 	/**
> 	 *	returns property with specified name and classname
> 	 */
> 	public CIMProperty getProperty(String propName, String originalClass) {
> 		return (getProperty(propName+"."+originalClass));
502,503d497
< 	return(meth);	  
<     }
505,510d498
<     //
<     // Adds a property to the class
<     //
<     public void addProperty(CIMProperty p) {
< 	properties.addElement(p);
<     }
512,517c500,516
<     //
<     // Returns the number of properties
<     //
<     public int numberOfProperties() {
< 	return(properties.size());
<     }
---
> 	/**
> 	 *	Returns all the methods of the class
> 	 *	doesn't include those which were overriden
> 	 */
> 	public Vector getMethods() {
> 		Vector methVect = new Vector();
> 		if(methods != null) {
> 			int size = methods.size();
> 			for(int i=0;i<size;i++){
> 				CIMMethod cimMeth = (CIMMethod) methods.elementAt(i);
> 				if((cimMeth.getOriginClass()).equalsIgnoreCase(this.name)) {
> 					methVect.addElement(cimMeth);
> 				}
> 			}	
> 		}	
> 		return methVect;
> 	}	
519,553d517
<     //
<     // Sets the properties for this class (old ones are removed)
<     //
<     public void setProperties(Vector table) {
< 	properties=table;
<     }
<     
<     //
<     // Adds a qualifier
<     public void addQualifier(CIMQualifier q) {
< 	//
< 	// See if qualifier already present
< 	//
< 	for(int i=0;i<qualifiers.size();i++) {
< 	    CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
< 	    
< 	    if (cq.equals(q)) {
< 		qualifiers.removeElementAt(i);
< 		break;
< 	    }
< 	}
< 	qualifiers.addElement(q);
<     }
<  
<     //
<     // Checks whether this class has the specified qualifier
<     //	
<     // Returns true if qualifier defined
<     //
<     public boolean hasQualifier(CIMQualifier q) {
< 	int i;
<     
< 	for(i=0;i<qualifiers.size();i++)
< 	    if (((CIMQualifier)(qualifiers.elementAt(i))).equals(q))
< 		return(true);
555,569c519,525
< 	return(false);
<     }
<  
<     //
<     // returns number of qualifiers
<     //
<     public int numberOfQualifiers() {
< 	return(qualifiers.size());
<     }
<     
<     //
<     // Removes a qualifier
<     // Returns true if the qualifier removed 
<     //
<     public boolean removeQualifier(CIMQualifier q) {
---
> 	/**
> 	 *	Returns all the methods of the class
> 	 *	Includes those which were overriden
> 	 */
> 	public Vector getAllMethods() {
> 		return this.methods;
> 	}	
571,577c527,531
< 	for(int i=0;i<qualifiers.size();i++) {
< 	    CIMQualifier cq=(CIMQualifier)(qualifiers.elementAt(i));
< 	    
< 	    if (cq.equals(q)) {
< 		qualifiers.removeElementAt(i);
< 		return(true);
< 	    }
---
> 	/**
> 	 *	returns method with specified name and classname
> 	 */
> 	public CIMMethod getMethod(String methName, String originalClass) {
> 		return (getMethod(methName+"."+originalClass));
579,597d532
< 	return(false);
<     }
<  
<  
<     //
<     // Sets the qualifiers (old qualifiers replaced)
<     //
<     public void setQualifiers(Vector table) {
< 	for(int i=0;i<table.size();i++) {
< 	    Object o=table.elementAt(i);
< 	    if (!(o instanceof CIMQualifier)) {
< 		//
< 		// Why doesn't this issue an exception...
< 		//
< 		return;
< 	    }
< 	}
< 	qualifiers=table;
<     }
600,615c535,541
<     //
<     // Adds a method
<     //
<     public void addMethod(CIMMethod m) {
< 	//for(int i=0;i<methods.size();i++) {
< 	//  CIMMethod cm=(CIMMethod)(methods.elementAt(i));
< 	//  
< 	//  if (cm.equals(m)) {
< 	//	methods.removeElementAt(i);
< 	//	break;
< 	//  }
< 	//}
< 	if (methods==null)
< 	    methods=new Vector();
< 	methods.addElement(m);
<     }
---
> 	/**
> 	 *	returns method with specified name
> 	 */
> 	public CIMMethod getMethod(String methName) {
> 		CIMMethod cm = null;
> 		String className = null;
> 		String mName = null;
617,622c543,551
<     //
<     // Sets methods (old methods replaced)
<     //
<     public void setMethods(Vector table) {
< 	methods=table;
<     }
---
> 		if (methName != null) {
> 			int i = methName.indexOf('.');
> 			if(i >=0 ) {
> 				//property name in form of classname.propertyname
> 				className = methName.substring(0,i);
> 				mName = methName.substring(i+1,methName.length());
> 			} else {
> 				mName = methName;
> 			}	
624,629c553,560
<     //
<     // Returns a new instance appropriately initialized
<     //
<     //
<     public CIMInstance newInstance() {
< 	CIMInstance cInstance=new CIMInstance();
---
> 			int size = methods.size();
> 			for(int j=0; j <size; j++){
> 				CIMMethod cimMeth = (CIMMethod)methods.elementAt(j);
> 				if(className != null) {
> 					if((cimMeth.getOriginClass()).equalsIgnoreCase(className)
> 					&&	((cimMeth.getName()).equalsIgnoreCase(mName))) {
> 						return cimMeth;
> 					}	
631,634c562,570
< 	Vector props=new Vector();
< 	for(int i=0;i<properties.size();i++) {
< 	    CIMProperty prop=(CIMProperty)(properties.elementAt(i));
< 	    props.addElement(prop.clone());
---
> 				} else {
> 					if((cimMeth.getName()).equalsIgnoreCase(mName)) {
> 						return cimMeth;
> 					}	
> 				}
> 
> 			}
> 		}	
> 		return cm;
636c572,593
< 	cInstance.setProperties(props);
---
> 
> 
> 	/**
> 	 *	adds specified method 
> 	 */
> 	public void addMethod(CIMMethod cimMeth) {
> 		methods.addElement(cimMeth);
> 	}	
> 
> 
> 	/**
> 	 *	Sets  methods of the class
> 	 */
> 	public void setMethods(Vector methVect) {
> 		this.methods = methVect;
> 	}	
> 
> 
> 	 //
>     // toString
>     public String toString() {
> 	int i;
638,641c595,606
< 	Vector quals=new Vector();
< 	for(int i=0;i<qualifiers.size();i++) {
< 	    CIMQualifier qual=(CIMQualifier)(qualifiers.elementAt(i));
< 	    quals.addElement(qual.clone());
---
> 	String ret=new String();
> 	
> 	if (qualifiers.size()!=0) {
> 	     ret=ret.concat("[\n");
> 	     if (isAssociation)
> 		ret=ret.concat("ASSOCIATION,");
> 	     for(i=0;i<qualifiers.size();i++) {
> 		if (i>0)
> 		    ret=ret.concat(",");
> 		ret=ret.concat(((CIMQualifier)(qualifiers.elementAt(i))).toMOF());
> 	     }
> 	     ret=ret.concat("]\n");
643c608,609
< 	cInstance.setQualifiers(quals);
---
> 	ret=ret.concat("class ");
> 	ret=ret.concat(getName());
645,647c611,617
< 	cInstance.setClassName(getName());
< 	return(cInstance);
<     }
---
> 	if (superClass!=null) {
> 	    ret=ret.concat(":");
> 	    ret=ret.concat(superClass);
> 	}
> 	ret=ret.concat("\n{\n");
> 	for(i=0;i<properties.size();i++)
> 	    ret=ret.concat(((CIMProperty)(properties.elementAt(i))).toMOF());
649,654c619,624
<  
<     //
<     // Returns an XML representation of this CIM class. 
<     //
<     public String toXml(boolean includeQualifiers) throws MalformedURLException {
< 	return(toXml(false,includeQualifiers,true,null));
---
> 	if (methods!=null) {
> 	    for(i=0;i<methods.size();i++)
> 		ret=ret.concat(((CIMMethod)(methods.elementAt(i))).toMOF());
> 	}
> 	ret=ret.concat("};\n");
> 	return(ret);
658,671c628
<     
<     //
<     // SUNDIFF - not supported
<     //
<     //public String toXml(CIMObjectPath cop) throws MalformedURLException {
<     //	  throw new MalformedURLException("");
<     //}
<  
<     //
<     // SUNDIFF - not supported
<     //
<     //public String toXml(CIMObjectPath cop,String host) throws MalformedURLException {
<     //	  throw new MalformedURLException("");
<     //}
---
> 	//TODO implement toXML and local elements and fileter methods
673,674c630
< 
<     //
---
> 	//
683,684c639,640
< 	localClass.parentClassName=parentClassName;	    // Name of parent class
< 	localClass.associationFlag=associationFlag;	       // TRUE if an association
---
> 	localClass.superClass=superClass;	    // Name of parent class
> 	localClass.isAssociation=isAssociation;	       // TRUE if an association
721,722c677,678
< 	localClass.parentClassName=parentClassName;	    // Name of parent class
< 	localClass.associationFlag=associationFlag;	       // TRUE if an association
---
> 	localClass.superClass=superClass;	    // Name of parent class
> 	localClass.isAssociation=isAssociation;	       // TRUE if an association
767,772c723,724
<     
<     //
<     // NOTSUN
<     //
<     
<     //
---
> 
> 	//
786c738
< 	if (parentClassName!=null)
---
> 	if (superClass!=null)
788c740
< 			    "\" SUPERCLASS=\""+parentClassName+"\">");
---
> 			    "\" SUPERCLASS=\""+superClass+"\">");
835d786
<     
837c788,789
<     
---
> 	//
>     // Returns an XML representation of this CIM class. 
839,846c791,792
<     // Breaks a string of the form x.y into two strings 'x' and 'y'
<     //
<     private String splitName1(String inName) {
< 	int i=inName.indexOf(".");
< 	if (i== -1)
< 	    return(null);
< 	
< 	return(inName.substring(0,i));
---
>     public String toXml(boolean includeQualifiers) throws MalformedURLException {
> 	return(toXml(false,includeQualifiers,true,null));
848,857c794
<     private String splitName2(String inName) {
< 	int i=inName.indexOf(".");
< 	if (i== -1)
< 	    return(inName);
< 	
< 	return(inName.substring(i+1,inName.length()));
<     }
<     //
<     // END NOTSUN
<     //
---
> 
