0a1,5
> /*
> static char sccsid[] = "@(#)92  1.1  src/com/ibm/cim/CIMScope.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:25";
> */
> 
> //------------------------------------------------------------------------------
2c7
< // CIMScope.java
---
> // Filename: CIMScope.java
4,6c9
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
---
> // Description: This represents a scope
8c11
< //	http://www.snia.org/resources/openSource.html
---
> // Change History:
10,56c13,17
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is CIMScope.java
< // 
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s): Peter Rivera
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2. 
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< // $Id$
< //
< // $Log$
< // Revision 1.7  2001/01/02 19:32:06  davidsi
< // - Added missing INSTANCE check for toMof() method.
< //
< // Revision 1.6  2000/11/06 18:13:21  davidsi
< // - Reconciled error ids.
< //
< // Revision 1.5  2000/08/16 05:59:52  shawn
< // merge P_TOMCAT31 branch
< //
< // Revision 1.4.8.1  2000/08/10 00:03:27  shawn
< // head merge
< //
< // Revision 1.4  2000/05/11 10:12:20  davidsi
< // - Fixed tabs.
< //
< // Revision 1.3  2000/05/06 17:04:23  davidsi
< // - Modifications to bring classes inline with the SUN WBEM APIs 2.2.
< //
< // Revision 1.2  2000/02/13 15:09:08  davidsi
< // - Added text to cover re-use of Solaris WBEM APIs.
< //
< // Revision 1.1.1.1  2000/02/06 16:41:03  davidsi
< // Initial version.
< //
< //
< //
< package org.snia.wbem.cim;
---
> //	Modifier			Date				Change ID
> // ------------------------------------------------------------------------------
> // Darshan Vora 			06-12-2002
> //	Initial creation
> //-------------------------------------------------------------------------------
57a19,21
> package com.ibm.cim;
> 
> 
60c24
< public class CIMScope extends Object implements Serializable {
---
> public class CIMScope implements Serializable {
62,93c26,35
<     private static final int BAD=0;	    // Indicates unset or bad
<     public static final int SCHEMA=1;	    // A CIM schema
<     public static final int CLASS=2;	    // A CIM class
<     public static final int ASSOCIATION=3;  // A CIM association
<     public static final int INDICATION=4;   // A CIM indication
<     public static final int PROPERTY=5;     // A CIM property
<     public static final int REFERENCE=6;    // A CIM reference
<     public static final int METHOD=7;	    // A CIM method
<     public static final int PARAMETER=8;    // A CIM parameter
<     public static final int INSTANCE=9;     // An instance (NOT SUN)
<     public static final int ANY=10;	    // Any CIM element
<     
<     private static CIMScope[] predefined=new CIMScope[11]; // Initializes an array of predefined CIM scope objects
<   
<     private int scope=BAD;
<     
<     static {
< 	int cnt=0;
< 	
< 	predefined[cnt++]=new CIMScope(SCHEMA);
< 	predefined[cnt++]=new CIMScope(CLASS);
< 	predefined[cnt++]=new CIMScope(ASSOCIATION);
< 	predefined[cnt++]=new CIMScope(INDICATION);
< 	predefined[cnt++]=new CIMScope(PROPERTY);
< 	predefined[cnt++]=new CIMScope(REFERENCE);
< 	predefined[cnt++]=new CIMScope(METHOD);
< 	predefined[cnt++]=new CIMScope(PARAMETER);
< 	predefined[cnt++]=new CIMScope(INSTANCE);
< 	predefined[cnt++]=new CIMScope(ANY);
< 	
<     }
<     
---
> 	public static final int	SCHEMA 		= 	0;
> 	public static final int CLASS 		= 	1;
> 	public static final int ASSOCIATION	=	2;
> 	public static final int INDICATION	= 	3;
> 	public static final int PROPERTY 	= 	4;
> 	public static final int REFERENCE 	= 	5;
> 	public static final int METHOD 		= 	6;
> 	public static final int PARAMETER 	= 	7;
> 	public static final int INSTANCE 	= 	8;
> 	public static final int ANY 		= 	9;
96,111c38
<     private boolean validScope(int iscope) {
< 	//
< 	// NOTE: has implicit knowledge of value scope values!
< 	//
< 	return(iscope>=SCHEMA && iscope<=ANY);
<     }
< 	
<  
<     // CIMScope 
<     //
<     public CIMScope(int iscope) {
< 	if (!validScope(iscope))
< 	    throw new ExceptionInInitializerError("Bad scope "+iscope);
< 	else
< 	    scope=iscope;  
<     }
---
> 	private int cimScope = -1;
113,120c40,89
<  
<  
<     // getScope 
<     //
<     // Returns a CIMScope with the specified scoping 
<     //
<     public static CIMScope getScope(int iscope) {
< 	int i;
---
> 	private static CIMScope[]  cimScopes = new CIMScope[10];
> 	static {
> 		cimScopes[0]= new CIMScope(SCHEMA);
> 		cimScopes[1]= new CIMScope(CLASS);
> 		cimScopes[2]= new CIMScope(ASSOCIATION);
> 		cimScopes[3]= new CIMScope(INDICATION);
> 		cimScopes[4]= new CIMScope(PROPERTY);
> 		cimScopes[5]= new CIMScope(REFERENCE);
> 		cimScopes[6]= new CIMScope(METHOD);
> 		cimScopes[7]= new CIMScope(PARAMETER);
> 		cimScopes[8]= new CIMScope(INSTANCE);
> 		cimScopes[9]= new CIMScope(ANY);
> 	}
> 
> 	/**
> 	 *	constructor
> 	 */
> 
> 	public CIMScope(int scope){
> 		if( !isValidScope( scope) ) {
> 			throw new IllegalArgumentException();
> 		} else {
> 			cimScope = scope;
> 		}
> 
> 	}
> 
> 
> 	/**
> 	 *	return the CIMScope
> 	 */
> 	 public static CIMScope getScope(int scope){
> 	 	if ( ( scope < CIMScope.SCHEMA) ||
> 				( scope > CIMScope.ANY)){
> 			throw new IllegalArgumentException();
> 		}
> 		return CIMScope.cimScopes[scope];
> 	 }
> 
> 	 /**
> 	  *	returns scope 
> 	  */
> 
> 	 public int getScope(){
> 	 	return this.cimScope;
> 	 }
> 
> 
> 
> 
122,124c91,103
< 	for(i=0;i<predefined.length;i++) {
< 	    if (predefined[i].scope==iscope)
< 		return(predefined[i]);
---
> 	/**
> 	 *  checks if scope is a valid  CIMSope 
> 	 */
> 
> 	private  boolean isValidScope(int scope){
> 
> 		if (( scope < SCHEMA ) || 
> 				(	scope > ANY)) {
> 			return false;
> 		} else {
> 			return true;
> 		}
> 
126,127c105
< 	return(null);
<     }
---
> 		
129,135c107,109
<     // getScope
<     //
<     // Returns the integer for the scope
<     //
<     public int getScope() {
< 	return(scope);
<     } 
---
> 	public boolean equals(Object obj) {
> 		if (!( obj instanceof CIMScope)) 
> 			return false;
136a111
> 		CIMScope scope = (CIMScope)obj;
138,149c113,115
<     // equals 
<     //
<     // Determines if the object is a valid CIM scope and is
<     // equal to this object
<     //
<     public boolean equals(Object o) {
<        if (! (o instanceof CIMScope) )
< 	   return(false);
<        
<        CIMScope cs=(CIMScope)o;
<        return(cs.scope==scope);
<     }
---
> 		return (scope.cimScope == this.cimScope);
> 				
> 	}
151,182c117
<  
<  
<  
<     // toString 
<     public String toString() {
< 	return(toMOF());
<     }
<  
<     // toMOF 
<     public String toMOF() {
< 	if (scope==SCHEMA)
< 	    return("SCHEMA");
< 	if (scope==CLASS)
< 	    return("CLASS");
< 	if (scope==ASSOCIATION)
< 	    return("ASSOCIATION");
< 	if (scope==INDICATION) 
< 	    return("INDICATION");
< 	if (scope==PROPERTY)
< 	    return("PROPERTY");
< 	if (scope==REFERENCE)
< 	    return("REFERENCE");
< 	if (scope==METHOD)
< 	    return("METHOD");
< 	if (scope==PARAMETER)
< 	    return("PARAMETER");
< 	if (scope==ANY)
< 	    return("ANY");
< 	if (scope==INSTANCE)
< 	    return("INSTANCE");		
< 	return("BAD SCOPE");
<     }
---
> 
