0a1,4
> /*
> static char sccsid[] = "@(#)60  1.1  src/com/ibm/cimom/tools/MOF.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:43:18";
> */
> //------------------------------------------------------------------------------
2c6
< // MOFComp.java
---
> // Filename: MOF.java
4,6c8
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
---
> // Description: This class defines the debugger service
8c10
< //	http://www.snia.org/resources/openSource.html
---
> // Change History:
10,57c12,16
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is MOFComp.java
< // 
< // The Initial Developer of the Original Code is David Simons.
< //
< // Contributor(s):
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2. 
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< // $Id$
< //
< // $Log$
< // Revision 1.7  2001/03/20 13:23:53  davidsi
< // - Added better messages.
< //
< // Revision 1.6  2000/11/12 14:39:49  davidsi
< // - Fixed typo from last merge.
< //
< // Revision 1.5  2000/11/11 15:28:56  davidsi
< // - From hfcheng, added support for forcing update.
< //
< // Revision 1.4  2000/08/16 05:59:58  shawn
< // merge P_TOMCAT31 branch
< //
< // Revision 1.3.8.1  2000/08/10 00:03:33  shawn
< // head merge
< //
< // Revision 1.3  2000/05/11 10:11:35  davidsi
< // - Fixed tabs.
< //
< // Revision 1.2  2000/05/06 17:07:51  davidsi
< // - Brought in line with SUN WBEM APIs 2.2
< // - Added message to show which MOF file is being compiled.
< //
< // Revision 1.1  2000/04/09 14:20:36  davidsi
< // - Initial version.
< //
< //
< //
< package org.snia.wbemcmd.mof;
---
> //  Modifier            Date                Change ID
> // ------------------------------------------------------------------------------
> //  Darshan Vora          06-13-2002
> //  Initial creation
> //-------------------------------------------------------------------------------
59,72c18
< import org.snia.wbemcmd.cimom.CommandClient;
< import java.util.Enumeration;
< import java.util.Vector;
< import java.net.MalformedURLException;
< import java.rmi.*;
< import java.rmi.server.*;
< import org.snia.wbem.cim.CIMException;
< import org.snia.wbem.cim.CIMObjectPath;
< import org.snia.wbem.cim.CIMNameSpace;
< import org.snia.wbem.cim.CIMQualifierType;
< import org.snia.wbem.cim.CIMInstance;
< import org.snia.wbem.cim.CIMClass;
< import org.snia.wbem.client.CIMOMHandle;
< import org.snia.wbem.client.CIMClient;
---
> package com.ibm.cimom.tools;
74c20,23
< class MOFComp {
---
> import com.ibm.cim.CIMNameSpace;
> import com.ibm.cim.CIMException;
> import com.ibm.cimom.datastore.CIMOMDataStore;
> import com.ibm.cimom.util.GlobalParms;
77,82c26,30
<     public static void main(String[] args) {
<         int i;
<         CIMClient cimClient;
<         boolean verbose=false;
<         CommandClient cmdClient=new CommandClient();
<         boolean forceUpdate=false;
---
> public class MOF {
> 	String nameSpace = CIMNameSpace.DEFAULT_NAMESPACE;
> 	String directory = "./";
> 	String mofFile;
> 	boolean verbose = false;
84,90c32,35
<         // Pam Wright, Imation Add message to indicate success or failure
<         try {
<             cimClient=cmdClient.parseConnection(args,new Vector());
<             if (cimClient==null) {
<                 System.out.println("MOFComp failed");
<                 System.exit(1);
<             }
---
> 	public void parse(String params[]) {
> 		String nFlag;
> 		String dFlag;
> 		String fFlag;
92,93c37,59
<             if (cmdClient.getVerbose()) 
<                 verbose=true;
---
> 		//parsing the command line parameter
> 		for (int i=0; i< params.length;i++) {
> 			/*if(params[i].equalsIgnoreCase("-n")) {
> 				if((params[i+1] != null) && (params[i+1].length() >0)) {
> 					nameSpace = params[i+1];
> 				} else {
> 					usage();
> 				}	
> 			} else */
> 			if( params[i].equalsIgnoreCase("-d")){
> 				if((params[i+1] != null) && (params[i+1].length() >0)) {
> 					directory = params[i+1];
> 				} else {
> 					usage();
> 				}	
> 			} else if( params[i].equalsIgnoreCase("-f")){
> 				if((params[i+1] != null) && (params[i+1].length() >0)) {
> 					mofFile = params[i+1];
> 				} else {
> 					usage();
> 				}	
> 			}
> 		}
95,96c61,63
<             if (cmdClient.getForceUpdate())
<                 forceUpdate=true;
---
> 		if(mofFile == null) {
> 			usage();
> 		}
98,106d64
<             for (i=0;i<args.length-1;i++) {
<                 if (args[i]==null)
<                     continue;
<             }
<             if (i>args.length || args.length==0  || args[i]==null) {
<                 System.err.println("A filename must be specified");
<                 System.out.println("MOFComp failed");
<                 System.exit(1);
<             }
108,109c66
<             String fileName=args[i];
<             System.err.println("Loading: "+fileName);
---
> 		CIMNameSpace ns = new CIMNameSpace(null,nameSpace);
111,112c68,74
<             CIMNameSpace nameSpace=new CIMNameSpace(cmdClient.getHostName(),
<                                                     cmdClient.getNameSpace());
---
> 		GlobalParms gbParams = new GlobalParms(null);
> 		CIMOMDataStore store = new CIMOMDataStore();
> 		//deleting old namespace 
> 		try {
> 			store.deleteNameSpace(nameSpace);
> 		} catch (CIMException ce) {
> 			System.out.println("CIMException "+ce.toString());
114,123c76,80
<             (new MOFParse()).mofParse(cimClient,
<                                       nameSpace,
<                                       "",
<                                       fileName,
<                                       new MOFMOFStatus(verbose),forceUpdate);
<             System.out.println("MOFComp complete");
<         }
<         catch (Exception e) {
<             System.out.println("Exception: " + e);
<             System.out.println("MOFComp failed");
---
> 		}
> 		System.out.println("Begining parsing for "+directory+mofFile);
> 		(new MOFParse()).mofParse( ns,directory, mofFile,new
> 		MOFMOFStatus(verbose));
>         System.out.println("Parsing Succefully completed for "+directory+mofFile);
125,127c82
<         }
<     }
< }
---
> 	}
128a84,103
> 
> 	public static void main( String args[]) {
> 
> 		if( ( args == null) || (args.length == 0 ) || (args.length >5) ) {
> 			//System.out.println("Usage : java MOF -n namespace -d directory -f moffile");
> 			System.out.println("Usage : java MOF -d directory -f moffile");
> 			System.exit(1);
> 		}
> 
> 		(new MOF()).parse(args);
> 	}
> 
> 
> 	private void usage() {
> 			//System.out.println("Usage : java MOF -n namespace -d directory -f moffile");
> 			System.out.println("Usage : java MOF -d directory -f moffile");
> 			System.exit(1);
> 	}	
> 
> }
