1,76c1,7
< //
< // IndSubscription.java
< //
< // The contents of this file are subject to the SNIA Public License Version 1.0
< // (the "License"); you may not use this file except in compliance with the
< // License. You may obtain a copy of the License at
< //
< //      http://www.snia.org/resources/openSource.html
< //
< // Software distributed under the License is distributed on an "AS IS" basis,
< // WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
< // License for the specific language governing rights and limitations
< // under the License.
< //
< // The Original Code is IndSubscription.java
< //
< // The Initial Developer of the Original Code is Adrian Schuur.
< //
< // Contributor(s):
< //
< //
< // This source uses the Solaris WBEM APIs version 2.2.
< // Synchronization will be maintained with the Solaris WBEM APIS,
< // which are being standardized through the Java Community Process.
< //
< //
< package org.snia.wbemcmd.indication;
< 
< 
< import java.util.*;
< import java.text.*;
< 
< import org.snia.wbem.cim.*;
< import org.snia.wbemcmd.cimom.*;
< import org.snia.wbemcmd.xml.*;
< import org.snia.wbem.client.*;
< 
< public class IndSubscription
< {
<    IndFilter fi=null;
<    IndHandler hi=null;
<    CIMInstance ci;
<    IndSubscription xx;
< 
<    IndSubscription(ProviderCIMOMHandle pch, CIMInstance ci,
<                                    CIMObjectPath fop, CIMInstance fci,
<                                    CIMObjectPath hop, CIMInstance hci)
<       throws CIMException
<    {
<       this.ci=ci;
<       fi=IndFilter.make(pch,fci,fop,this);
<       hi=IndHandler.make(pch,hci,hop,this);
<       IndicationProcessor.activateFilter(fi);
<       fi.addSubscription(this);
<       hi.addSubscription(this);
<    }
< 
<    static IndSubscription make(ProviderCIMOMHandle pch, CIMInstance ci,
<                                CIMObjectPath fop, CIMInstance fci,
<                                CIMObjectPath hop, CIMInstance hci)
<       throws CIMException
<    {
<       return new IndSubscription(pch,ci,fop,hci,hop,hci);
<    }
< 
<    public IndHandler getHandler()
<    {
<       return hi;
<    }
< 
<    public void remove()
<    {
<       fi.remSubscription(this);
<       hi.remSubscription(this);
<    }
< };
---
> /*
> static char sccsid[] = "@(#)75  1.1  src/com/ibm/cim/CIMIndSubscription.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:11";
> */
> package com.ibm.cim;
> 
> public class CIMIndSubscription {
> }
