1c1,4
< //
---
> /*
> static char sccsid[] = "@(#)82  1.1  src/com/ibm/cim/CIMNameSpace.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:17";
> */
> 
29a33
> //
79d82
< package org.snia.wbem.cim;
81c84,85
< import java.net.MalformedURLException;
---
> package com.ibm.cim;
> 
84,85c88,90
< import org.snia.wbemcmd.xml.XMLCIM;
< import org.snia.wbem.client.CIMClient;
---
> import java.net.MalformedURLException;
> import java.io.*;
> import com.ibm.xml.*;
86a92,100
> public class CIMNameSpace implements Serializable {
> 	
> 	public static final boolean BASIC_AUTHENTICATION = false;
> 	public static final boolean DIGEST_AUTHENTICATION= true;
> 	public static final String  DEFAULT_NAMESPACE = "\\root\\cimv2";
> 	public static final int DEFAULT_SSL_PORT = 5989;
> 	public static final int DEFAULT_NONSSL_PORT = 5988;
> 	public static final int DEFAULT_SSLIND_PORT = 5990;
> 	public static final int DEFAULT_NONSSLIND_PORT = 5987;
88,95c102,103
< /**
<  * This class represents a CIM namespace.  CIM namespace is a component of a
<  * CIM object name (namespace + model path) that provides a scope within which
<  * the objects are unique.
<  */
< public class CIMNameSpace extends Object implements Serializable {
<     // http default port is 5988
<     static public final int DEFAULT_PORT=5988;
---
> 	public static final int DEFAULT_PORT = DEFAULT_SSL_PORT;
> 	public static final int DEFAULT_IND_PORT = DEFAULT_SSLIND_PORT;
97,101c105,117
<     String nameSpace= CIMClient.DEFAULTNAMESPACE;
<     String hostName="127.0.0.1";
<     int portNumber=DEFAULT_PORT;
<     String protocol=new String("http");
<     String fileName=new String("/cimom");
---
> 	private String 	nameSpace =	DEFAULT_NAMESPACE;	
> 	private String	hostName =	null;	
> 	private URL	hostURL =	null;
> 	private int 	portNumber = DEFAULT_PORT;
> 	private int		indicationPort = DEFAULT_IND_PORT;
> 	private String 	protocol =	"http";
> 	private String 	language =	null;
> 	private boolean	authentication = CIMNameSpace.BASIC_AUTHENTICATION;
> 	private boolean	http11 = true;
> 	private boolean 	closeConnections = false;
> 	private boolean 	indications = false;
>     private String trustStore    = null;   // Location of truststore
>     private String trustPassword = null;   // Password of the truststore
103,108d118
<    /***
<     * Constructs a default instance (for localhost's CIM namespace
<     * "\Root\CIMV2").
<     */
<     public CIMNameSpace() {
<     }
109a120,122
> 	//Constructor
> 	public CIMNameSpace(){
> 		this(null, null);
111,122c124
<     /**
<      * Constructs an instance on the specified host's CIM namespace
<      *  "\Root\CIMV2").
<      * @param host Host information (host name or URL spec).
<      *   <br><ul><li> "myhost"
<      *   <li> "http://myhost/cimom" or "http://myhost:8080/cimom"
<      *   <li> "//myhost/cimom" or "//myhost:8080/cimom"
<      *</ul>
<      **/
<     public CIMNameSpace(String host){
<      	this(host, null);
<     }
---
> 	}
125,158c127,136
<     /**
<      * Constructs an instance on the specified host's specified CIM namespace.<p>
<      * Note: This method uses a very simplistic approach to differentiate the
<      * two formats of the 1st paramter.
<      * If the string does not contain any slash ('/') character, it is assumed
<      * to be a simple host name.  Otherwise, it is assumed to be a URL spec.
<      * <p>
<      *   @param host                 Host information (host name or URL spec).
<      * <br><ul><li> "myhost"
<      * <li> "http://myhost/cimom" or "http://myhost:8080/cimom"
<      * <li> "//myhost/cimom" or "//myhost:8080/cimom"
<      *</ul>
<      *   @param ns                   Name of the CIM namespace
<      **/
<     public CIMNameSpace(String host,String ns){
< 	try {
< 	    if (host !=null) {
< 		// if no slash in the parameter, assume it to be the host name
< 		if (host.indexOf('/') == -1)
< 		    hostName = host;
< 		// if at least one slash, consider it to be a URL spec.
< 		else {
< 		    // Use default data to provide the context URL
< 		    URL context = new URL (protocol, host, fileName);
< 	    	    URL url = new URL(context, host);
< 		    hostName = url.getHost();
< 		    //protocol = url.getProtocol();    // always use HTTP
< 		    portNumber=url.getPort();
< 		    // if port number is not specified, use http default port
< 		    if (portNumber == -1)
< 		        portNumber = DEFAULT_PORT;
< 		    // Should be "/cimom", but some servers (e.g., Solaris) may have
< 		    // a special URL for custom purposes.
< 		    fileName = url.getFile();
---
> 	//Constructor
> 	public CIMNameSpace(String host){
> 		this(host,null);
> 
> 	}
> 
> 	//Constructor
> 	public CIMNameSpace(String host, String namespace){
>  		if(namespace != null){
> 			this.nameSpace = namespace;
160,164d137
< 	    }
< 	} catch (MalformedURLException me) {
< 	    System.out.println("Exception: "+me);
< 	    // use default Host (localhost) and URL
<         }
166,169c139,140
< 	// use specified namespace
< 	if (ns != null)
< 	    nameSpace = ns;
<     }
---
> 		this.nameSpace = this.nameSpace.replace('/', File.separatorChar);
> 		this.nameSpace = this.nameSpace.replace('\\', File.separatorChar);
171c142,151
<     
---
> 		if(host == null) {
> 			//use default data to construct name space
> 		} else {
> 			if (host.indexOf('/') == -1) {
> 				this.hostName = host;
> 			} else {
> 			    if(host.startsWith("https")) {
> 				System.setProperty("java.protocol.handler.pkgs","com.ibm.net.ssl.internal.www.protocol");
>                          java.security.Security.addProvider(new com.ibm.jsse.IBMJSSEProvider());
> 			    }
173,181c153,163
<     
<    /** 
<     * Gets (path)name of namespace
<     * 
<     * @return        (path)name of CIM namespace.
<     **/
<     public String getNameSpace(){
< 	return(nameSpace);
<     }
---
> 			    try {
> 				hostURL = new URL(host);
> 				this.hostName = hostURL.getHost();
> 				this.portNumber = hostURL.getPort();
> 				this.protocol = hostURL.getProtocol();
> 			    }catch (MalformedURLException e ) {
> 				if ((host.indexOf('/') >= 0) || (host.indexOf('\\')>=0))
> 				throw new IllegalArgumentException(host);
> 			    }
> 			}
> 		}
182a165
> 	}
184,191d166
<    /**
<     * Gets the host url of this CIM namespace
<     * 
<     * @return  a URL instance representing this CIM namespace.
<     **/
<     public String getHost(){
< 	return(hostName);
<     }
193,203c168,233
<    /**
<     * Gets the host url of this CIM namespace
<     *
<     * @return	A URL instance representing this CIM namespace.
<     */
<     public java.net.URL getHostURL() {
< 	URL hostURL;
< 	try {
< 	    hostURL=new URL(protocol, hostName, portNumber, fileName);
< 	} catch (MalformedURLException me) {
< 	    hostURL=null;
---
> 	/**
> 	 * 	Returns Host name
> 	 */
> 	public String getHost() {
> 		return hostName;
> 	}	
> 
> 	/**
> 	 * 	Sets Host name
> 	 */
> 	public void setHost(String hName) {
> 		hostName = hName;
> 	}	
> 
> 
> 	/**
> 	 * 	Returns Host  URL
> 	 */
> 	public URL getHostURL() {
> 		return hostURL;
> 	}	
> 	
> 	/**
> 	 * 	Sets Host name
> 	 */
> 	public void setHostURL(String hURL) {
> 		try {
> 			hostURL = new URL(hURL);
> 			this.hostName = hostURL.getHost();
> 			this.portNumber = hostURL.getPort();
> 				this.protocol = hostURL.getProtocol();
> 			}catch (MalformedURLException e ) {
> 				if ((hURL.indexOf('/') >= 0) || (hURL.indexOf('\\')>=0))
> 				throw new IllegalArgumentException(hURL);
> 			}
> 	}	
> 
> 
> 	/**
> 	 *	Returns NameSpace
> 	 */
> 	public String getNameSpace() {
> 		return nameSpace;
> 	}	
> 
> 	/**
> 	 *	Sets NameSpace
> 	 */
> 	public void setNameSpace(String ns) {
> 		nameSpace=ns;
> 	}	
> 
> 
> 
> 	/**
> 	 *	Returns PortNumber
> 	 */
> 	public int getPort() {
> 		return portNumber;
> 	}	
> 
> 	/**
>        *	Returns indication port
> 	 */
> 	public int getIndPort() {
> 		return indicationPort;
205c235,293
< 	return(hostURL);
---
> 	
> 	/**
> 	 *	Sets PortNumber
> 	 */
> 	public void setPort(int  port) {
> 		if ( ( port < 0) || (port > 65535)){
> 			throw new IllegalArgumentException(" Invalid Port Number");
> 		}	
> 		portNumber = port;
> 	}	
> 
> 	private String validate(String ns){
> 		return null;
> 	}
> 
> 	/**
> 	 *	Sets indicationPort
> 	 */
> 	public void setIndPort(int  port) {
> 		if ( ( port < 0) || (port > 65535)){
> 			throw new IllegalArgumentException(" Invalid Port Number");
> 		}	
> 		indicationPort = port;
> 	}	
> 
> 	/**
> 	 *	Returns Protocol
> 	 */
> 	public String getProtocol() {
> 		return protocol;
> 	}	
> 
> 
> 	/**
> 	 *	Sets Protocol
> 	 */
> 	public void setProtocol(String proto) {
> 		if (proto.equalsIgnoreCase("http") == false &&
> 		    proto.equalsIgnoreCase("https") == false) {
> 			throw new IllegalArgumentException(" Invalid Protocol");
> 		}
> 
> 		protocol=proto;
> 		if (protocol.equals("https") == true) {
> 			portNumber=DEFAULT_SSL_PORT;
> 		} else {
> 			portNumber=DEFAULT_NONSSL_PORT;
> 		}
> 	}	
> 
> 	public void setSSL() {
> 		setProtocol("https");
> 	}
> 
>     public void setTrustStore(String location,
>                               String password)
>     {
>         trustStore    = location;
>         trustPassword = password;
207,223c295,298
<     
<    /**
<     * parses the name of a namespace by replacing the forward slash (/) with
<     * a backward slash (\). For example, if you pass the name of the default
<     *  namespace, /cim/v2, this routine replaces this string with \cim\v2.
<     * <p>
<     *    [TBD]:  Sun's interface definition (no return value) seems to be in error.
<     *            String is immutable, and replacing input String instance with a 
<     *            newly modified String instance on stack does not do much for 
<     *           the user.  So, we will return the new String for now, and send 
<     *           a clarification query to Sun/JSR-000048 folks.
<     * <p>
<     * @param p  the string to parse
<     * @return   a new String with backslashes.
<     **/
<     public String parse(String p) {
< 	return p.replace('/', '\\');
---
> 
>     public String getTrustStore()
>     {
>         return trustStore;
225,237d299
<      
<      
<  
<    /***
<     * Sets namespace
<     *
<     * @param ns  the string representing the name of this CIM namespace
<     */
<     public void setNameSpace(String ns) {
< 	nameSpace=ns;
<     }
<      
<      
239,244c301,303
<     /**
<      * Sets host name
<      * @param h  the string representing the host name of this CIM namespace
<      **/
<     public void setHost(String h){
< 	hostName=h;
---
>     public String getTrustPassword()
>     {
>         return trustPassword;
246a306,311
> 	public boolean isSSL() {
> 		if (protocol.equals("https") == true) {
> 			return true;
> 		}
> 		return false;
> 	}
248,259c313,318
<     /***
<      *
<      * Returns a String representation of the CIMNameSpace.
<      * This is expected to be implementation specific, and the names of 
<      * namespace and host are used for this implementation. <p>
<      * @return   A String representation of this instance.
<      */
<     public String toString(){
< 	return("CIMNameSpace="+nameSpace+" [host "+hostName+"]");
<     }
<  
<  
---
> 	/**
> 	 *	Returns language
> 	 */
> 	public String getLanguage() {
> 		return language;
> 	}	
261c320,404
<     /***
---
> 
> 	/**
> 	 *	Sets Language 
> 	 */
> 	public void setLanguage(String lang) {
> 		language = lang;
> 	}	
> 
> 
> 	/**
> 	 *	Returns Authentiation
> 	 */
> 	public boolean getAuthentication() {
> 		return authentication;
> 	}	
> 
> 
> 	/**
> 	 *	Sets the authentication
> 	 */
> 	public void setAuthentication(boolean auth) {
> 		authentication = auth;
> 	}	
> 
> 	public void setDigest() {
> 		authentication = DIGEST_AUTHENTICATION;
> 	}
> 
> 	/**
> 	 *	Sets the HTTP1.1
> 	 */
> 	public void setHttp11() {
> 		http11 = true;
> 	}	
> 
> 	/**
> 	 *	Sets the HTTP1.0
> 	 */
> 	public void setHttp10() {
> 		http11 = false;
> 	}	
> 
> 	/**
> 	 *	Checks for HTTP1.1
> 	 */
> 	public boolean isHttp11() {
> 		return http11;
> 	}	
> 
> 	/**
> 	 *	Sets close connection
> 	 */
> 	public void setCloseConnections() {
> 		closeConnections = true;
> 	}
> 
> 	/**
> 	 *	Checks close connection
> 	 */
> 	public boolean getCloseConnections() {
> 		return closeConnections;
> 	}
> 
> 	/**
> 	 *	Sets indications
> 	 */
> 	public void setIndications() {
> 		indications = true;
> 	}
> 
> 	/**
> 	 *	Checks indications
> 	 */
> 	public boolean getIndications() {
> 		return indications;
> 	}
> 
> 	/**
> 	 *	Replaces '/' forward slashes with '\' backward slashes
> 	 */
> 	public String parse(String  ns) {
> 		return ns.replace('/' , '\\');
> 	}	
> 
> 	/***
296a440
> 
308,341d451
<     }
<     
<     //
<     // NOT SUN
<     //
<    /**
<     * gets the Port Number<p>
<     * @return The port number used to access the namespace
<     *         represented by this instance.
<     */
<     public int getPortNumber() {
< 	return(portNumber);
<     }
< 
< 
<    /**
<     * get the protocol<p>
<     * 
<     * @return  The protocol used to access the namespace 
<     *          represented by this instance.
<     */
<     public String getProtocol() {
< 	return(protocol);
<     }
< 
< 	
<    /**
<     * get the file name <p>
<     * 
<     * @return The filename of the URL representing this
<     *         namespace instance.
<     */
<     public String getFileName() {
< 	return(fileName);
