1c1,4
< //
---
> /*
> static char sccsid[] = "@(#)88  1.1  src/com/ibm/cim/CIMParameter.java, cimom, ICAT1, ICAT1_1.0.0.7 10/10/02 14:42:22";
> */
> 
53d55
< package org.snia.wbem.cim;
55c57,59
< import java.io.*;
---
> package com.ibm.cim;
> 
> 
58c62
< import org.snia.wbemcmd.xml.*;
---
> import com.ibm.xml.*;
60,62c64
< public class CIMParameter extends CIMElement implements Cloneable {
<     CIMDataType datatype=null;
<     Vector qualifiers=null;
---
> public class CIMParameter extends CIMElement implements Cloneable{
63a66,74
> 	/**
> 	 * datatype of parameter
> 	 */
> 	private CIMDataType datatype;
> 	
> 	/**
> 	 *	Qualifiers of parameter
> 	 */
> 	private Vector		qualifiers;
65,68d75
<     // CIMParameter 
<     //
<     public CIMParameter() {
<     }
69a77,83
> 	/**
> 	 *	constructor
> 	 */
> 	public CIMParameter(){
> 		super("");
> 		qualifiers = new Vector();
> 	}
71,78d84
<     //
<     // CIMParameter 
<     // 
<     // Creates a parameter with a name
<     //
<     public CIMParameter(String name){
< 	setName(name);
<     }
80c86,95
<     // CIMMethod
---
> 	/**
> 	 *	constructor  with name
> 	 */
> 	public CIMParameter(String name){
> 		super(name);
> 		qualifiers = new Vector();
> 	}
> 
> 
> // CIMParameter
144,156d158
<     
<     //
<     // setQualifiers 
<     //
<     // Sets the qualifiers
<     //
<     public void setQualifiers(Vector list){
< 	int tsize=list.size();
< 	for(int i=0;i<tsize;i++)
< 	    if (!(list.elementAt(i) instanceof CIMQualifier))
< 		return;
< 	qualifiers=list;
<     }
157a160,165
> 	/**
> 	 *	returns CIMDataType of parameter
> 	 */
> 	public CIMDataType getType(){
> 		return datatype;
> 	}
159,166d166
<     //
<     // getQualifiers 
<     //
<     // Returns the qualifiers 
<     //
<     public Vector getQualifiers(){
< 	return(qualifiers);
<     }
167a168,173
> 	/**
> 	 *	sets CIMDataType of parameter
> 	 */
> 	public void setType(CIMDataType type){
> 		datatype = type;
> 	}
168a175,180
> 	/**
> 	 *	returns qualifiers of parameter
> 	 */
> 	public Vector getQualifiers(){
> 		return qualifiers;
> 	}
170,176c182,193
<     // setType 
<     //
<     // Sets the data type 
<     //
<     public void setType(CIMDataType type){
< 	datatype=type;
<     }
---
> 	/**
> 	 *	sets qualifiers of parameter
> 	 */
> 	public void setQualifiers(Vector qualifiers){
> 		
> 		for(int i=0; i< qualifiers.size(); i++) {
> 			if( !(qualifiers.elementAt(i) instanceof CIMQualifier)) {
> 				return;
> 			}
> 		}	
> 		this.qualifiers = qualifiers;
> 	}
177a195,206
> 	/**
> 	 *	returns qualifier for given name
> 	 */
> 	public CIMQualifier getQualifier(String qName) {
> 		for(int i=0; i< qualifiers.size(); i++) {
> 			CIMQualifier  qualifier = (CIMQualifier)qualifiers.elementAt(i);
> 			if ( (qualifier.getName()).equalsIgnoreCase(qName)) {
> 				return qualifier;
> 			}	
> 		}
> 		return null;
> 	}
179,185c208,213
<     // getType 
<     //
<     // Returns the data type
<     //
<     public CIMDataType getType(){
< 	return(datatype);
<     }
---
> 	/**
> 	 *	returns size of the paramter
> 	 */
> 	public int getSize(){
> 		return datatype.getSize();
> 	}
186a215,227
> 	/**
> 	 * creates a new copy of CIMParameter
> 	 */
> 	public Object clone() {
> 		CIMParameter cimParameter = new CIMParameter();
> 		cimParameter.datatype = this.datatype;
> 		cimParameter.name = this.name;
> 		cimParameter.identifier = this.identifier;
> 		Vector qVect = new Vector();
> 		for( int i=0; i<this.qualifiers.size() ; i++) {
> 			qVect.addElement( qualifiers.elementAt(i));
> 		}
> 		cimParameter.qualifiers = qVect;
188,227c229
<     // getSize 
<     //
<     // Returns the size of this parameter 
<     //
<     public int getSize(){
< 	return(datatype.getSize());
<     }
< 
< 
< 
<     // setSize 
<     //
<     // Sets the size of this parameter
<     //
<     // public void setSize(int aSize){
<     // SUNDIFF : Why? The datatype does this for us
<     //}
< 
< 
<     //toString 
<     public String toString(){
< 	return("CIMParameter("+getName()+")");
<     }
< 
< 
<     //toMOF 
<     public String toMOF(){
< 	String ret;
< 	int i;
< 	
< 	ret=new String();
< 	if (qualifiers!=null && qualifiers.size()>0) {
< 	    ret=ret.concat("[");
< 	    for(i=0;i<qualifiers.size();i++) {
< 		CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
< 		if (i>0)
< 		    ret=ret.concat(",");
< 		ret=ret.concat(nq.toMOF());
< 	    }
< 	    ret=ret.concat("]");
---
> 		return cimParameter;
228a231,243
>  
>     //toMOF 
> 	public String toMOF(){
> 		String ret;
> 		int i; 
> 		ret=new String();
> 		
> 		if (qualifiers!=null && qualifiers.size()>0) {
> 			ret=ret.concat("[");
> 			for(i=0;i<qualifiers.size();i++) {
> 				CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
> 				if (i>0)
> 					ret=ret.concat(",");
230,247c245,252
< 	
< 	ret=ret.concat(datatype.toMOF());
< 	ret=ret.concat(" ");
< 	ret=ret.concat(getName());
< 	return(ret);
<     }
< 
< 
< 
<     //clone 
<     public Object clone(){
< 	CIMParameter cp=new CIMParameter();
< 	
< 	cp.datatype=datatype;
< 	if (qualifiers!=null) {
< 	    cp.qualifiers=new Vector();
< 	    for(int i=0;i<qualifiers.size();i++)
< 		cp.qualifiers.addElement(qualifiers.elementAt(i));
---
> 				ret=ret.concat(nq.toMOF()); 
> 			} 
> 			ret=ret.concat("]");
> 		} 
> 		ret=ret.concat(datatype.toMOF()); 
> 		ret=ret.concat(" ");
> 		ret=ret.concat(getName());
> 		return(ret);
249,250d253
< 	return(cp);
<     }
252,253c255,256
< 
<     //toXml 
---
>  
>    //toXml 
341,357c344
<     // getQualifier 
<     //
<     // Returns a qualifier
<     //
<     public CIMQualifier getQualifier(String name) {
< 	int i;
< 	if (qualifiers!=null) {
< 	    int tsize=qualifiers.size();
< 	    for(i=0;i<tsize;i++) {
< 		CIMQualifier nq=((CIMQualifier)(qualifiers.elementAt(i)));
< 		if (nq.getName().equalsIgnoreCase(name)) {
< 		   return(((CIMQualifier)(qualifiers.elementAt(i))));
< 		} 
< 	    }
< 	}
< 	return(null);
<     }
---
> 
